var _class, _temp2;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import { Component } from 'react';
import UAParser from 'ua-parser-js';
import idx from 'idx';

var doesNotMatch = function doesNotMatch(_ref
// $FlowFixMe
) {
  var target = _ref.target,
      parsedTarget = _ref.parsedTarget,
      predicateKey = _ref.predicateKey;
  return target && !(idx(parsedTarget, function (_) {
    return _[predicateKey].toLowerCase();
  }) || '').includes(target);
};

var _default = (_temp2 = _class = function (_Component) {
  _inherits(_default, _Component);

  function _default() {
    var _temp, _this, _ret;

    _classCallCheck(this, _default);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      parsedUserAgent: null,
      shouldRender: false,
      userAgent: null
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _default.prototype.render = function render() {
    var children = this.props.children;
    var _state = this.state,
        parsedUserAgent = _state.parsedUserAgent,
        shouldRender = _state.shouldRender,
        userAgent = _state.userAgent;

    if (shouldRender) {
      return typeof children === 'function' ? children({ parsedUserAgent: parsedUserAgent, userAgent: userAgent }) : children;
    }
    return null;
  };

  return _default;
}(Component), _class.defaultProps = {
  browser: null,
  device: null,
  os: null
}, _class.getDerivedStateFromProps = function (props) {
  var userAgent = window.navigator.userAgent;
  var parser = new UAParser(userAgent);
  var browser = props.browser,
      device = props.device,
      os = props.os;


  var parsedBrowser = parser.getBrowser();
  var parsedDevice = parser.getDevice();
  var parsedOS = parser.getOS();

  // If the parsed device object is empty, then we can assume that the device is a computer.
  if (!parsedDevice.type) {
    parsedDevice.type = 'computer';
  }

  // Figure out if the target user agent attributes match the actual user agent. If they all match, then render.
  var shouldRender = true;
  if (doesNotMatch({
    target: browser,
    parsedTarget: parsedBrowser,
    predicateKey: 'name'
  })) {
    shouldRender = false;
  }
  if (doesNotMatch({
    target: device,
    parsedTarget: parsedDevice,
    predicateKey: 'type'
  })) {
    shouldRender = false;
  }
  if (doesNotMatch({ target: os, parsedTarget: parsedOS, predicateKey: 'name' })) {
    shouldRender = false;
  }

  var parsedUserAgent = {
    browser: parsedBrowser,
    device: parsedDevice,
    os: parsedOS
  };

  return {
    parsedUserAgent: parsedUserAgent,
    shouldRender: shouldRender,
    userAgent: userAgent
  };
}, _temp2);

export { _default as default };